function Cmp00500_RegiaoNaoAtendidaPeloFornecedor(General, RestEngine, ScreenService, MessageService, templateManager, ZHPromise, ZhFilterPreferences, maskEngine, ZhUtil) {
    /*global Constants*/
    var self = this;
    
    this.setDataSourceFilter = function(args) {
        var row = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        widget.dataSourceFilter = [{
            "name": "P_CDFORNECED",
            "operator": "=",
            "value": row.CDFORNECED
        }];
        self.setStripeValues(widget);

        widget.reload();
        widget.activate();
    };
    this.setValue = function(widget){
        if(!widget.currentRow.REPORT) {
            widget.currentRow.REPORT = "CMP00500";
        }
      
    };
    self.setStripeValues = function(widget) {
         var mask = {
			type: "CPFCNPJ",
			params: {}
		};
	
        var stripe = templateManager.container.getWidget('stripe');
        var filterRow = widget.appliedFilter.FILTER_ROW;

        stripe.currentRow.NRINSJURFORN = Util.applyMask(filterRow.NRINSJURFORN, mask, maskEngine, ZhUtil);
        stripe.currentRow.NMFANTFORN = filterRow.NMFANTFORN;

        stripe.reload();
    };

    this.addRegiao = function(widget) {
        if (widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtendida'));
            MessageService.showMessageByCode("NECE_FORN_FILTER");
        } else {
            ScreenService.openSwipe(widget.widgets[0]).then(function(success) {
                widget.widgets[0].edit();
            });
        }
    };
    this.saveRegiao = function(widget) {
        if (widget.isValid()) {
            const currentRow = angular.copy(widget.currentRow);
            
            currentRow.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;

            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/saveRegiao', 'DataSet', [currentRow]).then(function(res) {
                var resp = res.dataset.verificacao[0];
                if (resp == 'S') {
                    General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/verificaFilialReg', 'DataSet', [currentRow]).then(function(response) {
                        var erro = response.dataset.erro[0];
                        if (erro == 1) {
                            ScreenService.confirmMessage("Atenção! Fornecedor atende a unidades da região informada. Ao confirmar, essas unidades e a região como um todo não serão mais atendidas pelo fornecedor. Confirma a operação?", 'question', function(success) {
                                General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/insertRegiao', 'Row', currentRow).then(function(response) {
                                    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                                    widget.getParent().reload();
                                });
                                
                            }.bind(this), function(error) {});
                        }
                        else{
                            MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                        }
                    });
                }
                self.clearRow(widget);
                ScreenService.closeSwipe().then(function(success) {
                    widget.getParent().reload();
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    this.regiaoDelete = function(widget) {
        var regiaoArray = [];

        widget.dataSource.data.forEach(function(regiao) {
            if (regiao.__isSelected) {
                regiaoArray.push(regiao);
            }
        });
        ScreenService.confirmMessage("Deseja excluir o(s) registro(s) selecionado(s)?", 'question', function (success) {
            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/regiaoDelete', 'Row', regiaoArray).then(function(res) {
                widget.unSelectAll();
                widget.reload();
                MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    this.backSwipe = function(args) {
        args.owner.widget.currentRow = {};
        ScreenService.closeSwipe();
    };
    this.clearRow = function(widget) {
        widget.currentRow = {};
      
    };
    this.backPopup = function(widget) {
        self.clearRow(widget);
        if (widget.name == templateManager.container.getWidget('exportWidget').name) {
            widget.getField('NMRAZSOCFORNDEST').readOnly = true;
            widget.getField('CDREGIAO').readOnly = true;
        }

        ScreenService.closePopup();
    };
    this.openReportWidget = function(widget) {
        var relatorio = widget.container.getWidget('reporttWidget');
        ScreenService.openPopup(relatorio).then(function(success) {
            relatorio.edit();
        });
    };
    this.generateReport = function(widget) {
        if (widget.isValid()) {
            var reportName = widget.currentRow.REPORT;
            widget.currentRow.CDFORNECED2 = widget.currentRow.CDFORNECED ? Array.isArray(widget.currentRow.CDFORNECED) ? widget.currentRow.CDFORNECED.join('_') : 'T' : 'T';
            if(!widget.currentRow.CDFORNECED2 ) {
                widget.currentRow.CDFORNECED1 = ' ';
            }
            else {
                widget.currentRow.CDFORNECED1 =  widget.currentRow.CDFORNECED2;
            }
           
           
            General.openReportPopup(widget, self.abreRelatorio, [widget, widget.currentRow, reportName]);
        }
    };

    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/generateReport', reportName, row);
    };

    this.openExportWidget = function(widget) {
        widget.currentRow = widget.appliedFilter.FILTER_ROW;
        var exportar = widget.container.getWidget('exportWidget');
        if (widget.currentRow.CDFORNECED) {
                exportar.currentRow.NMRAZSOCFORNORIG = widget.currentRow.NMRAZSOCFORN;
                exportar.currentRow.CDFORNECEDORIG = widget.currentRow.CDFORNECED;
                exportar.getField('NMRAZSOCFORNDEST').readOnly = false;
                exportar.getField('CDREGIAO').readOnly = false;
                self.setFornDestDataFilter(exportar);
        }
        ScreenService.openPopup(exportar).then(function(success) {
           
            exportar.edit();


        });
    };
    this.setFornDestDataFilter = function(widget) {
        if (widget.currentRow.NMRAZSOCFORNORIG.length > 0) {

            widget.getField('NMRAZSOCFORNDEST').readOnly = false;
            widget.getField('CDREGIAO').readOnly = false;

            widget.getField('NMRAZSOCFORNDEST').dataSourceFilter = [{
                "name": "P_CDFORNECED",
                "operator": "=",
                "value": widget.currentRow.CDFORNECEDORIG
            },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMRAZSOCFORN",
                        "direction": "ASC"
                    }
                ]
            }];
            

        } else {
            widget.getField('NMRAZSOCFORNDEST').readOnly = true;
            widget.getField('CDREGIAO').readOnly = true;
        }
    };
    this.exportRegiao = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.CDFORNECEDDEST = widget.currentRow.CDFORNECEDDEST ? Array.isArray(widget.currentRow.CDFORNECEDDEST) ? widget.currentRow.CDFORNECEDDEST.join('_') : 'T' : 'T';
            widget.currentRow.CDREGIAO = widget.currentRow.CDREGIAO ? Array.isArray(widget.currentRow.CDREGIAO) ? widget.currentRow.CDREGIAO.join('_') : 'T' : 'T';
            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/verificaExportacao', 'DataSet', [widget.currentRow]).then(function(res) {
                var resp = res.dataset.dados;
                if (Util.isEmptyObject(resp[0])) {
                    ScreenService.closePopup();
                    var widErro = templateManager.container.getWidget('erroExportacao');
                    ScreenService.showMessage('Operação bloqueada! Fornecedores atendem a unidades de uma ou mais regiões escolhidas.').then(function(success) {
                        widErro.dataSource.data = resp[1];
                        ScreenService.openPopup(widErro);
                        self.clearRow(widget);
                    });
                } else if (Util.isEmptyObject(resp[1])) {
                    ScreenService.closePopup();
                    ScreenService.showMessage(resp[0]);
                    self.clearRow(widget);
                }

            }, function(err) {
                ScreenService.showMessage(err.data.error);


            });
        }
    };

    this.editSwipe = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.setDataSourceAux = function(widget) {
        var fornec = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
        var fieldRegiao = widget.getField('CDREGIAO');
        fieldRegiao.dataSourceFilter = [{
            "name": "P_CDFORNECED",
            "operator": "=",
            "value": fornec
        }];

        fieldRegiao.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp00500_RegiaoNaoAtendidaPeloFornecedor', Cmp00500_RegiaoNaoAtendidaPeloFornecedor);
});