var Cmp05500_AfsGeralPorAfsFornecedor_Controller = function (ScreenService, General, restEngine, templateManager, Utilities, MessageService, ZhFilterPreferences) {

    var self = this;
    
    //Armazena o pacote de modulos
    var requestModulesMetadata = function() {
        var modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function(response) {
            return response.data;
        });
    };
    
    this.valoresDefault = function(widget) {
        const filialField = widget.getField("CDFILIAL");
            
        filialField.value(getLocalVar("NMFILIAL"));
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
	        const filterRow = {
	            DT_INTERVAL: {
                    'formattedStart' : moment().format('DD/MM/YYYY'),
                    'start'          : moment().format('DD/MM/YYYY'),
                    'formattedEnd'   : moment().format('DD/MM/YYYY'),
                    'end'            : moment().format('DD/MM/YYYY')
                },
	            IDTIPOLANCAF: 'T',
                CDFILIAL: [ getLocalVar("CDFILIAL") ? getLocalVar("CDFILIAL") : response.dataset.data.CDFILIAL ],
                NMFILIAL: [ getLocalVar("NMFILIAL") ? getLocalVar("NMFILIAL") : response.dataset.data.NMFILIAL ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                
                filterRow.CDFILIAL = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                
                filialField.value(NMFILCENTCMP);
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    ZhFilterPreferences.openFilterWidget(widget, filterRow).then(opened => {
                        const activeWidget = templateManager.container.getActiveWidget();
                        
                        activeWidget.getField("CDFILIAL").reload().then(function() {
                            activeWidget.activate();
                        
                            ScreenService.hideLoader();
                        });
                    });
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.filterProperties.readOnly == true) {
                        filialField.filterProperties.validations.required = true;
                            
                        MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
                            
                        delete filterRow.CDFILIAL;
                        delete filterRow.NMFILIALSOL;
                        filialField.reload();
                    
                        ZhFilterPreferences.openFilterWidget(widget, filterRow).then(opened => {
                            const activeWidget = templateManager.container.getActiveWidget();
                            
                            activeWidget.getField("CDFILIAL").reload().then(function() {
                                activeWidget.activate();
                                
                                ScreenService.hideLoader();
                            });
                        });
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.clearDefaultFilterGeralAf = function (args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.applyFilterGeralAf = function(args) {
        //const reportName = "CMP05500";
        let widget = args.owner;
        let row = args.e.preference.FILTER_ROW;

        if(widget.isValid()) {
            
    		row.NAOCONSIDERA = 'T';
            row.L_CDGRUPFILI = row.NAOCONSIDERA == 'N'? row.CDGRUPFILI ? row.CDGRUPFILI : "T" : "T";
            //row.L_FILIAL = row.CDFILIAL.join('_');
            row.L_FILIAL = !row.CDFILIAL || Util.isEmptyObject(row.CDFILIAL) ? 'T' : row.L_FILIAL = '_' + row.CDFILIAL.join('_') + '_';
            row.L_FORNECEDOR = !row.FORNECEDOR || Util.isEmptyObject(row.FORNECEDOR) ? 'T' : row.L_FORNECEDOR = '_' + row.FORNECEDOR.join('_') + '_';
            
            row.DATAINI = row.DT_INTERVAL.start;
    		row.DATAFIN = row.DT_INTERVAL.end;
    		row.SEPFORNECEDOR = "F";
    		
    		row.MODO = 'N';
    		
    		widget.dataSourceFilter = [
                { "name": "P_CDPRODINI",    "operator": "=", "value": row.CDPRODINI             },   
    		    { "name": "P_CDPRODFIM",    "operator": "=", "value": row.CDPRODFIN             },
    		    { "name": "P_PAGINA",       "operator": "=", "value": row.SEPFORNECEDOR         }, 
    		    { "name": "P_DATAINI",      "operator": "=", "value": row.DATAINI  	            }, 
    		    { "name": "P_DATAFIM",      "operator": "=", "value": row.DATAFIN	            },
    		    { "name": "L_FILIAL",       "operator": "=", "value": row.L_FILIAL              },
    		    { "name": "L_CDFORNECEDOR", "operator": "=", "value": row.L_FORNECEDOR          },
    		    { "name": "P_CDPRODINICOC", "operator": "=", "value": row.CDPRODINI             },
    		    { "name": "P_CDPRODFIMCOC", "operator": "=", "value": row.CDPRODFIN             },
    		    { "name": "P_MODO",         "operator": "=", "value": row.MODO                  },   
    		    { "name": "P_NRORG",        "operator": "=", "value": getLocalVar('NRORG')      },
    		    { "name": "P_CDOPERADOR",   "operator": "=", "value": getLocalVar("CDOPERADOR") },
    		    { "name": "P_IDTIPOLANCAF", "operator": "=", "value": row.IDTIPOLANCAF          }
            ];
            
            setStripeGeraAf(row);
            
            widget.reload();
        }
    };
    
    function setStripeGeraAf(row) {
        const widStripe = templateManager.container.getWidget('stripe');
        const stripeRow = widStripe.currentRow;
        
        stripeRow.CDPRODINI = row.NMPRODUTOINI;
        stripeRow.CDPRODFIN = row.NMPRODUTOFIM;
        stripeRow.DTENTREGA = ScreenService.i18n("De ") + row.DT_INTERVAL.start + ScreenService.i18n(" até ") + row.DT_INTERVAL.end;
    }

    this.filtraUnidades = function(widget) {
        widget.currentRow.NMFILIAL = "";
        if(widget.currentRow.NMGRUPFILI)
            widget.getField("NMFILIAL").dataSourceFilter[0].value = widget.currentRow.CDGRUPFILI;
        else
            widget.getField("NMFILIAL").dataSourceFilter[0].value = "T";
        widget.getField("NMFILIAL").reload();
    };
    
    //Reponsável por chamar a function para redirecionar para a tela/window Gestão de Estoque OL(Neogrid)
    this.openWindowGestaoEstoqueOL = function () {
        this.openWindow('cmp#gestao_estoque_ol_neogrid');
    };
    
    //Reponsável por chamar a function para redirecionar para a tela/window de Teste de Envio de Emails Compras
    this.openWindowTesteEnvioEmailCompras = function () {
        this.openWindow('cmp#teste_envio_email_compras');
    };
    
    //Redireciona outra tela/window
    this.openWindow = function(windowName, newWindow) {
        requestModulesMetadata().then(function(modules) {
            var subModule = windowName.split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            ScreenService.openLink(url, false);
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp05500_AfsGeralPorAfsFornecedor_Controller', Cmp05500_AfsGeralPorAfsFornecedor_Controller);
});